﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace ExpenseReport.Data
{
    internal class ExpenseReportManager
    {
        private ExpenseReportDatabaseEntities _Context;
        private ExpenseReportDatabaseEntities Context
        {
            get
            {
                if (_Context == null)
                {
                    _Context = new ExpenseReportDatabaseEntities();
                }

                return _Context;
            }
        }

        internal int CreateExpenseReport(decimal amount, string description)
        {
            ExpenseReport expenseReport = new ExpenseReport()
                {
                    Amount = amount,
                    Description = description,
                    Status = ExpenseReportStatus.Created
                };

            Context.AddToExpenseReports(expenseReport);
            Context.SaveChanges();

            return expenseReport.Id;
        }

        internal void ApproveExpenseReport(int id)
        {
            UpdateExpenseReportStatus(id, ExpenseReportStatus.Approved);
        }

        internal void DenyExpenseReport(int id)
        {
            UpdateExpenseReportStatus(id, ExpenseReportStatus.Denied);
        }

        internal ExpenseReport[] GetPendingExpenseReports()
        {
            return (from er in Context.ExpenseReports
                    where er.Status == ExpenseReportStatus.Created
                    select er).ToArray();
        }

        private void UpdateExpenseReportStatus(int id, string status)
        {
            ExpenseReport expenseReport = GetExpenseReport(id);

            expenseReport.Status = status;
            Context.SaveChanges();
        }

        private ExpenseReport GetExpenseReport(int id)
        {
            return (from er in Context.ExpenseReports
                    where er.Id == id
                    select er).FirstOrDefault();
        }
    }
}