﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ManagerApplication
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void GetPendingExpenseReports()
        {
            PendingExpenseReportServiceReference.ServiceClient proxy = new PendingExpenseReportServiceReference.ServiceClient();
            var expenses = proxy.GetPendingExpenseReports();

            ExpensesDataGrid.ItemsSource = expenses;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            GetPendingExpenseReports();
        }

        private void RefreshButton_Click(object sender, RoutedEventArgs e)
        {
            GetPendingExpenseReports();
        }

        private void ApproveButton_Click(object sender, RoutedEventArgs e)
        {
            ApproveExpenseReport(true, string.Format("Expense report {0} was approved", IdTextBox.Text));
        }

        private void ApproveExpenseReport(bool expenseReportApproved, string displayMessage)
        {
            int expenseReportId;
            if (int.TryParse(IdTextBox.Text, out expenseReportId))
            {
                SendApprovalMessage(expenseReportId, expenseReportApproved);
                MessageBox.Show(displayMessage);
                GetPendingExpenseReports();
            }
        }

        private void SendApprovalMessage(int expenseReportId, bool expenseReportApproved)
        {
            ExpenseReportServiceReference.ServiceClient proxy = new ExpenseReportServiceReference.ServiceClient();
            proxy.ApproveExpense(expenseReportId, expenseReportApproved);
        }

        private void DenyButton_Click(object sender, RoutedEventArgs e)
        {
            ApproveExpenseReport(false, string.Format("Expense report {0} was denied", IdTextBox.Text));
        }
    }
}